VERSION 5.00
Begin VB.UserControl Splitter 
   CanGetFocus     =   0   'False
   ClientHeight    =   975
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1575
   HasDC           =   0   'False
   KeyPreview      =   -1  'True
   LockControls    =   -1  'True
   ScaleHeight     =   65
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   105
   ToolboxBitmap   =   "Splitter.ctx":0000
   Begin VB.Image imgHorizontally 
      Enabled         =   0   'False
      Height          =   480
      Left            =   840
      Picture         =   "Splitter.ctx":00FA
      Top             =   240
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgVertically 
      Enabled         =   0   'False
      Height          =   480
      Left            =   240
      Picture         =   "Splitter.ctx":0404
      Top             =   240
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Shape shpBox 
      BackColor       =   &H80000010&
      BackStyle       =   1  'Opaque
      Height          =   735
      Left            =   120
      Top             =   120
      Visible         =   0   'False
      Width           =   1335
   End
End
Attribute VB_Name = "Splitter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private fBusy As Boolean
Private fBusyResize As Boolean
Private fBusyDrag As Boolean
Private fBusyArrange As Boolean
Private fDragMode As Boolean
Private vDragMouse As Long
Private vDragPos As Single

Public Enum SplitterOrientationEnum
  SplitterOrientationVertically = 1
  SplitterOrientationHorizontally = 2
End Enum

Private varOrientation As SplitterOrientationEnum
Private varImmediateArrange As Boolean
Private varThickness As Long
Private varMin As Single
Private varMax As Single

Private colControls As Collection, colMargins As Collection, colAnchors As Collection

Private Type ControlsType
  Object As Control
  Margin As Long
  Anchor As Long
End Type

Public Event SplitStart(ByVal Position As Single)
Attribute SplitStart.VB_Description = "  ."
Public Event SplitMove(ByVal NewPosition As Single, ByVal Delta As Single)
Attribute SplitMove.VB_Description = " ."
Attribute SplitMove.VB_MemberFlags = "200"
Public Event SplitEnd(ByVal Position As Single)
Attribute SplitEnd.VB_Description = "   ."
Public Event SplitCancel(ByVal Position As Single)
Attribute SplitCancel.VB_Description = "   ."

Private Function ScaleToParent(ByVal Pixels As Long, Optional ByVal GetPosition As Boolean) As Single
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    ScaleToParent = UserControl.ScaleX(Pixels, ScaleModeConstants.vbPixels, IIf(GetPosition, ScaleModeConstants.vbContainerPosition, ScaleModeConstants.vbContainerSize))
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    ScaleToParent = UserControl.ScaleY(Pixels, ScaleModeConstants.vbPixels, IIf(GetPosition, ScaleModeConstants.vbContainerPosition, ScaleModeConstants.vbContainerSize))
End Select
End Function

Private Function ScaleToPixels(ByVal Parent As Single, Optional ByVal GetPosition As Boolean) As Long
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    ScaleToPixels = UserControl.ScaleX(Parent, IIf(GetPosition, ScaleModeConstants.vbContainerPosition, ScaleModeConstants.vbContainerSize), ScaleModeConstants.vbPixels)
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    ScaleToPixels = UserControl.ScaleY(Parent, IIf(GetPosition, ScaleModeConstants.vbContainerPosition, ScaleModeConstants.vbContainerSize), ScaleModeConstants.vbPixels)
End Select
End Function

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "  (/)."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute Enabled.VB_UserMemId = -514
Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
UserControl.Enabled = NewValue
shpBox.BackColor = IIf(NewValue, SystemColorConstants.vbButtonShadow, SystemColorConstants.vbButtonFace)
PropertyChanged "Enabled"
End Property

Public Property Get ImmediateArrange() As Boolean
Attribute ImmediateArrange.VB_Description = "        ."
Attribute ImmediateArrange.VB_ProcData.VB_Invoke_Property = ";Behavior"
ImmediateArrange = varImmediateArrange
End Property

Public Property Let ImmediateArrange(ByVal NewValue As Boolean)
varImmediateArrange = NewValue
PropertyChanged "ImmediateArrange"
End Property

Public Property Get Thickness() As Long
Attribute Thickness.VB_Description = "   ."
Thickness = varThickness
End Property

Public Property Let Thickness(ByVal NewValue As Long)
If NewValue < 1& Then NewValue = 1&
varThickness = NewValue
UserControl_Resize
PropertyChanged "Thickness"
End Property

Public Property Get Min() As Single
Attribute Min.VB_Description = "   ,  0,    ."
Attribute Min.VB_ProcData.VB_Invoke_Property = ";Position"
Min = varMin
End Property

Public Property Let Min(ByVal NewValue As Single)
If NewValue < 0 Then NewValue = 0
varMin = NewValue
PropertyChanged "Min"
End Property

Public Property Get Max() As Single
Attribute Max.VB_Description = "   ,  0,    ."
Attribute Max.VB_ProcData.VB_Invoke_Property = ";Position"
Max = varMax
End Property

Public Property Let Max(ByVal NewValue As Single)
If NewValue < 0 Then NewValue = 0
varMax = NewValue
PropertyChanged "Max"
End Property

Public Property Get Pos() As Single
Attribute Pos.VB_Description = "  ."
Attribute Pos.VB_UserMemId = 0
Attribute Pos.VB_MemberFlags = "600"
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    Pos = UserControl.Extender.Left + UserControl.Extender.Width / 2
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    Pos = UserControl.Extender.Top + UserControl.Extender.Height / 2
  Case Else
    Exit Property
End Select
End Property

Public Property Let Pos(ByVal NewValue As Single)
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    UserControl.Extender.Left = NewValue - UserControl.Extender.Width / 2
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    UserControl.Extender.Top = NewValue - UserControl.Extender.Height / 2
  Case Else
    Exit Property
End Select
End Property

Public Property Get Orientation() As SplitterOrientationEnum
Attribute Orientation.VB_Description = "  (/)."
Attribute Orientation.VB_ProcData.VB_Invoke_Property = ";Appearance"
Orientation = varOrientation
End Property

Public Property Let Orientation(ByVal NewValue As SplitterOrientationEnum)
Select Case NewValue
  Case SplitterOrientationEnum.SplitterOrientationVertically
    If NewValue <> varOrientation Then
      fBusyResize = True
      UserControl.Extender.Height = UserControl.Extender.Width
      fBusyResize = False
    End If
    varOrientation = NewValue
    Set UserControl.MouseIcon = imgVertically.Picture
    UserControl.MousePointer = MousePointerConstants.vbCustom
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    If NewValue <> varOrientation Then
      fBusyResize = True
      UserControl.Extender.Width = UserControl.Extender.Height
      fBusyResize = False
    End If
    varOrientation = NewValue
    Set UserControl.MouseIcon = imgHorizontally.Picture
    UserControl.MousePointer = MousePointerConstants.vbCustom
  Case Else
    UserControl.MousePointer = MousePointerConstants.vbDefault
    Exit Property
End Select
UserControl_Resize
PropertyChanged "Orientation"
End Property

Private Sub UserControl_Initialize()
Set colControls = New Collection
Set colMargins = New Collection
Set colAnchors = New Collection
End Sub

Private Sub UserControl_Terminate()
ControlClear
Set colControls = Nothing
Set colMargins = Nothing
Set colAnchors = Nothing
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
If Not (KeyCode = vbKeyEscape And Shift = 0) Then Exit Sub
KeyCode = 0
Cancel
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button <> vbLeftButton Then Exit Sub
If Not UserControl.Enabled Then Exit Sub
If fDragMode Then Exit Sub
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    vDragMouse = X
    vDragPos = UserControl.Extender.Left
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    vDragMouse = Y
    vDragPos = UserControl.Extender.Top
  Case Else
    Exit Sub
End Select
fDragMode = True
UserControl.BackColor = SystemColorConstants.vbButtonShadow
RaiseEvent SplitStart(vDragPos)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button <> vbLeftButton Then Exit Sub
If Not fDragMode Then Exit Sub
If fBusyDrag Or fBusyArrange Or fBusyResize Then Exit Sub
Dim Delta As Long, DeltaPos As Single, NewPos As Single
fBusyDrag = True
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    Delta = X - vDragMouse
    DeltaPos = UserControl.ScaleX(Delta, ScaleModeConstants.vbPixels, ScaleModeConstants.vbContainerPosition)
    NewPos = UserControl.Extender.Left + DeltaPos
    If varMin > 0 And NewPos < varMin Then NewPos = varMin
    If varMax > 0 And NewPos + ScaleToParent(varThickness) > varMax Then NewPos = varMax - ScaleToParent(varThickness)
    UserControl.Extender.Left = NewPos
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    Delta = Y - vDragMouse
    DeltaPos = UserControl.ScaleY(Delta, ScaleModeConstants.vbPixels, ScaleModeConstants.vbContainerPosition)
    NewPos = UserControl.Extender.Top + DeltaPos
    If varMin > 0 And NewPos < varMin Then NewPos = varMin
    If varMax > 0 And NewPos + ScaleToParent(varThickness) > varMax Then NewPos = varMax - ScaleToParent(varThickness)
    UserControl.Extender.Top = NewPos
End Select
fBusyDrag = False
If varImmediateArrange Then Arrange
RaiseEvent SplitMove(NewPos, DeltaPos)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button <> vbLeftButton Then Exit Sub
If Not fDragMode Then Exit Sub
UserControl.BackColor = SystemColorConstants.vbButtonFace
fDragMode = False
If varImmediateArrange Then Arrange
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    RaiseEvent SplitEnd(UserControl.Extender.Left)
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    RaiseEvent SplitEnd(UserControl.Extender.Top)
End Select
End Sub

Private Sub UserControl_Show()
shpBox.Visible = Not Ambient.UserMode
Orientation = varOrientation
End Sub

Private Sub UserControl_Resize()
If fBusyResize Then Exit Sub
fBusyResize = True
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    UserControl.Extender.Width = ScaleToParent(varThickness)
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    UserControl.Extender.Height = ScaleToParent(varThickness)
End Select
fBusyResize = False
shpBox.Move UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, UserControl.ScaleHeight
End Sub

Private Sub UserControl_InitProperties()
UserControl.Enabled = True
varOrientation = IIf(UserControl.Width > UserControl.Height, SplitterOrientationEnum.SplitterOrientationHorizontally, SplitterOrientationEnum.SplitterOrientationVertically)
varImmediateArrange = False
varThickness = 4&
varMin = 0&
varMax = 0&
shpBox.BackColor = IIf(UserControl.Enabled, SystemColorConstants.vbButtonShadow, SystemColorConstants.vbButtonFace)
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
varOrientation = PropBag.ReadProperty("Orientation", IIf(UserControl.Width > UserControl.Height, SplitterOrientationEnum.SplitterOrientationHorizontally, SplitterOrientationEnum.SplitterOrientationVertically))
varImmediateArrange = PropBag.ReadProperty("ImmediateArrange", False)
varThickness = PropBag.ReadProperty("Thickness", 4&)
varMin = PropBag.ReadProperty("Min", 0&)
varMax = PropBag.ReadProperty("Max", 0&)
shpBox.BackColor = IIf(UserControl.Enabled, SystemColorConstants.vbButtonShadow, SystemColorConstants.vbButtonFace)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
PropBag.WriteProperty "Enabled", UserControl.Enabled, True
PropBag.WriteProperty "Orientation", varOrientation, IIf(UserControl.Width > UserControl.Height, SplitterOrientationEnum.SplitterOrientationHorizontally, SplitterOrientationEnum.SplitterOrientationVertically)
PropBag.WriteProperty "ImmediateArrange", varImmediateArrange, False
PropBag.WriteProperty "Thickness", varThickness, 4&
PropBag.WriteProperty "Min", varMin, 0&
PropBag.WriteProperty "Max", varMax, 0&
shpBox.BackColor = IIf(UserControl.Enabled, SystemColorConstants.vbButtonShadow, SystemColorConstants.vbButtonFace)
End Sub

Public Sub Arrange()
Attribute Arrange.VB_Description = "     ."
Attribute Arrange.VB_UserMemId = -550
If fBusyArrange Then Exit Sub
If Not UserControl.Enabled Then Exit Sub
Dim ctl As Control, M As Long, A As Single, P As Single
Dim L As Single, T As Single, W As Single, H As Single
fBusyArrange = True
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    P = ScaleToPixels(UserControl.Extender.Left, True)
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    P = ScaleToPixels(UserControl.Extender.Top, True)
End Select
For Each ctl In colControls
  M = colMargins.Item(CStr(ObjPtr(ctl)))
  A = colAnchors.Item(CStr(ObjPtr(ctl)))
  L = ctl.Left
  T = ctl.Top
  W = ctl.Width
  H = ctl.Height
  Select Case varOrientation
    Case SplitterOrientationEnum.SplitterOrientationVertically
      Select Case M
        Case Is < 0
          If A = 0! Then
            L = ScaleToParent(P - ScaleToPixels(W) + 1 + M, True)
          Else
            L = A
            W = ScaleToParent(P - ScaleToPixels(L, True) + 1 + M)
          End If
        Case Is > 0
          If A = 0! Then
            L = ScaleToParent(P + varThickness - 1 + M, True)
          Else
            L = ScaleToParent(P + varThickness - 1 + M, True)
            W = A - L + ScaleToParent(1, True)
          End If
      End Select
    Case SplitterOrientationEnum.SplitterOrientationHorizontally
      Select Case M
        Case Is < 0
          If A = 0! Then
            T = ScaleToParent(P - ScaleToPixels(H) + 1 + M, True)
          Else
            T = A
            H = ScaleToParent(P - ScaleToPixels(T, True) + 1 + M)
          End If
        Case Is > 0
          If A = 0! Then
            T = ScaleToParent(P + varThickness - 1 + M, True)
          Else
            T = ScaleToParent(P + varThickness - 1 + M, True)
            H = A - T + ScaleToParent(1, True)
          End If
      End Select
  End Select
  If W < 0 Then W = 0
  If H < 0 Then H = 0
  ctl.Move L, T, W, H
Next ctl
fBusyArrange = False
End Sub

Public Sub Cancel()
Attribute Cancel.VB_Description = "   ."
If Not fDragMode Then Exit Sub
fBusyDrag = True
Select Case varOrientation
  Case SplitterOrientationEnum.SplitterOrientationVertically
    UserControl.Extender.Left = vDragPos
  Case SplitterOrientationEnum.SplitterOrientationHorizontally
    UserControl.Extender.Top = vDragPos
End Select
fBusyDrag = False
UserControl.BackColor = SystemColorConstants.vbButtonFace
fDragMode = False
If varImmediateArrange Then Arrange
RaiseEvent SplitCancel(vDragPos)
End Sub

Public Sub ControlAdd(ControlObject As Control, ByVal Margin As Long, Optional ByVal Anchor As Single = 0!)
Attribute ControlAdd.VB_Description = "         ."
If ControlObject Is Me Then Exit Sub
If Not (Extender.Container Is ControlObject.Container) Then Exit Sub
If Margin = 0& Then Exit Sub
colControls.Add Key:=CStr(ObjPtr(ControlObject)), Item:=ControlObject
colMargins.Add Key:=CStr(ObjPtr(ControlObject)), Item:=Margin
colAnchors.Add Key:=CStr(ObjPtr(ControlObject)), Item:=Anchor
End Sub

Public Sub ControlRemove(ControlObject As Control)
Attribute ControlRemove.VB_Description = "         ."
Dim ID As Long
On Error Resume Next
ID = ObjPtr(colControls.Item(CStr(ObjPtr(ControlObject))))
If Err.Number <> 0 Then ID = 0
On Error GoTo 0
If ID = 0 Then Exit Sub
colControls.Remove CStr(ID)
colMargins.Remove CStr(ID)
colAnchors.Remove CStr(ID)
End Sub

Public Sub ControlClear()
Attribute ControlClear.VB_Description = "      ."
Do While colControls.Count > 0
  colControls.Remove 1
Loop
Do While colMargins.Count > 0
  colMargins.Remove 1
Loop
Do While colAnchors.Count > 0
  colAnchors.Remove 1
Loop
End Sub

Public Sub ControlSetMargin(ControlObject As Control, ByVal NewMargin As Long)
Attribute ControlSetMargin.VB_Description = "        ."
Dim ID As Long
On Error Resume Next
ID = ObjPtr(colControls.Item(CStr(ObjPtr(ControlObject))))
If Err.Number <> 0 Then ID = 0
On Error GoTo 0
If ID = 0 Then Exit Sub
colMargins.Remove CStr(ID)
colMargins.Add Key:=CStr(ID), Item:=NewMargin
End Sub

Public Sub ControlSetAnchor(ControlObject As Control, ByVal NewAnchor As Single)
Attribute ControlSetAnchor.VB_Description = "      ."
Dim ID As Long
On Error Resume Next
ID = ObjPtr(colControls.Item(CStr(ObjPtr(ControlObject))))
If Err.Number <> 0 Then ID = 0
On Error GoTo 0
If ID = 0 Then Exit Sub
colAnchors.Remove CStr(ID)
colAnchors.Add Key:=CStr(ID), Item:=NewAnchor
End Sub
